package eu.etaxonomy.taxeditor.navigation;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.PlatformUI;

import eu.etaxonomy.cdm.model.taxon.Classification;
import eu.etaxonomy.taxeditor.newWizard.NewClassificationWizard;
import eu.etaxonomy.taxeditor.view.ICdmViewer;

public class NavigationCdmViewer implements ICdmViewer {


    @SuppressWarnings("unused")
    private final Logger logger = Logger.getLogger(NavigationCdmViewer.class);

    @Override
    public void show(Object input, Class<?> viewerClass) {
        if(viewerClass.equals(NewClassificationWizard.class)){
            if(input instanceof Classification){
                Classification classification = (Classification)input;
                NewClassificationWizard classificationWizard = new NewClassificationWizard();
                classificationWizard.init(null, null);
                classificationWizard.setEntity(classification);
                WizardDialog dialog = new WizardDialog(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), classificationWizard);
                dialog.open();
            }
        }
    }

    @Override
    public Map<Class<?>, String> getViewerClasses(Object input) {
        Map<Class<?>, String> viewerNameMap = new HashMap<Class<?>, String>();
        if(input instanceof Classification){
            viewerNameMap.put(NewClassificationWizard.class, "Classification Wizard");
        }
        return viewerNameMap;
    }

}
