// $Id$
/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.navigation.key.polytomous.operation;

import java.util.List;
import java.util.UUID;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;

import eu.etaxonomy.cdm.api.application.CdmChangeEvent.Action;
import eu.etaxonomy.cdm.api.service.IPolytomousKeyService;
import eu.etaxonomy.cdm.api.service.UpdateResult;
import eu.etaxonomy.cdm.model.description.PolytomousKey;
import eu.etaxonomy.taxeditor.operation.RemotingCdmUpdateOperation;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author cmathew
 * @date 25 Jun 2015
 *
 */
public class RemotingDeletePolytomousKeyOperation extends RemotingCdmUpdateOperation {

    private final static String LABEL = "Delete Polytomous Key operation";

    private final List<UUID> keysToDelete;
    /**
     * @param label
     * @param action
     * @param source
     * @param async
     */
    public RemotingDeletePolytomousKeyOperation(Object source,
            boolean async,
            List<UUID> keysToDelete) {
        super(LABEL, Action.Delete, source, async);
        this.keysToDelete = keysToDelete;
    }

    /* (non-Javadoc)
     * @see eu.etaxonomy.taxeditor.operation.RemotingCdmUpdateOperation#doUpdateExecute(org.eclipse.core.runtime.IProgressMonitor, org.eclipse.core.runtime.IAdaptable)
     */
    @Override
    protected UpdateResult doUpdateExecute(IProgressMonitor monitor, IAdaptable info) throws Exception {
        entityType = PolytomousKey.class;
        return CdmStore.getService(IPolytomousKeyService.class).delete(keysToDelete);
    }

}
