package eu.etaxonomy.taxeditor.navigation.navigator.handler;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.cdm.model.taxon.Classification;
import eu.etaxonomy.taxeditor.model.AbstractUtility;
import eu.etaxonomy.taxeditor.model.MessagingUtils;
import eu.etaxonomy.taxeditor.navigation.NavigationUtil;
import eu.etaxonomy.taxeditor.navigation.navigator.TaxonNavigator;
import eu.etaxonomy.taxeditor.navigation.operation.CreateNewTaxonHierarchyOperation;
import eu.etaxonomy.taxeditor.store.StoreUtil;

public class CreateClassificationHierarchyHandler extends AbstractHandler {

    private static final Logger logger = Logger.getLogger(CreateClassificationHierarchyHandler.class);


    /*
     * (non-Javadoc)
     *
     * @see
     * org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.
     * ExecutionEvent)
     */
    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        ISelection currentSelection = HandlerUtil.getCurrentSelection(event);
        if (currentSelection instanceof IStructuredSelection) {
            Object selectedElement = ((IStructuredSelection) currentSelection).getFirstElement();
            if (selectedElement instanceof Classification) {

                Classification classification = (Classification) selectedElement;
                try {
                    TaxonNavigator taxonNavigator = (TaxonNavigator)AbstractUtility.showView(TaxonNavigator.ID);
//                    IClassificationService service = CdmStore.getService(IClassificationService.class);

                    // Map<String, List<TaxonNode>> sortedGenusList =
                    // service.getSortedGenusList(classification.getAllNodes());


                    CreateNewTaxonHierarchyOperation operation = new CreateNewTaxonHierarchyOperation("Create Taxon Hierarchy", StoreUtil.getUndoContext(),classification,NavigationUtil.getNavigator(false), NavigationUtil.getNavigator(false) );

                    AbstractUtility.executeOperation(operation);
//                    UpdateResult result = service.createHierarchyInClassification(classification, null);
//
//                    Classification classification2 = CdmBase.deproxy(result.getCdmEntity(), Classification.class);
//
//                    Set<CdmBase> updatedObjects = result.getUpdatedObjects();
//
//                    Shell activeShell = HandlerUtil.getActiveShell(event);

//                    MessagingUtils.messageDialog("Add Hierarchy successful",
//                            FixClassificationHierarchyHandler.class, "Operation 'Fix Hierarchy' was successful. New classification is "
//                    + classification2.getTitleCache() + "\nUpdated Objects: " + updatedObjects.size());
                    //Success
                    taxonNavigator.refresh();
                } catch (Exception e) {
                    MessagingUtils.messageDialog("Failed to open Editor", CreateClassificationHierarchyHandler.class,
                            "Could not open ChecklistView. The hierarchy is corrupted!", e);
                }
            }
        }
        return null;
    }

}
